﻿var ver = "1.1.0"; 

var host = "http://develop.ime.ro";

function OpacRecord(index, rId, title, author, publisher, language, isbn, issn, sourceName, sourceType, coverHref) {
	this.index = index;
	this.rId = rId;
    this.title = title;
    this.author = author;
    this.publisher = publisher; 
    this.language = language; 
    this.isbn = isbn; 
    this.issn = issn; 
    this.sourceName = sourceName; 
    this.sourceType = sourceType;
    this.coverHref= coverHref;
    
    this.toJSON = function () {
     var template = '<div class="result">';
     
     template += '<div class="number">';
     template += this.index + '. ';
     template += '</div>';
     
     template += '<div class="productImage">';
     template += '<img border="0" src="' + this.coverHref +'" />';
     template += '</div>';
     //=====================================
     template += '<div class="productData">';
     var page = '/opac/external_bibliographic_view/' + this.rId + "?source=" + encodeURIComponent(this.sourceName);
     if(this.sourceType == 'local') {
    	 page = '/opac/bibliographic_view/' + this.rId;
     }
     
     template += '<div class="productTitle">';
     template += '<a href="' + host + page + '">';
     template += this.title;
     template += '</a>';
     template += '</div>';
     
     template += '<div class="author">';
     template += '<span>Source: </span>' + this.sourceName;
     template += '</div>';
     
     if(this.author != null) {
	     template += '<div class="author">';
	     template += '<span>by: </span>' + this.author;
	     template += '</div>';
     }
     
     if(this.publisher != null) {
	     template += '<div class="author">';
	     template += '<span>Publisher: </span>' + this.publisher;
	     template += '</div>';
     }
     
     if(this.language != null) {
	     template += '<div class="author">';
	     template += '<span>Language: </span>' + this.language;
	     template += '</div>';
     }
     
     if(this.isbn != null) {
	     template += '<div class="author">';
	     template += '<span>ISBN: </span>' + this.isbn;
	     template += '</div>';
     }
     
     template += '</div>';
     //====================================
     template += '</div>';
     template += '<br/>';
     return template;
  };  
}

document.onreadystatechange = function() 
{    
    if(document.readyState=="complete")
    { 
     	// callable from flyout
     	document.getResultFunc = function() { getResult(); }
     	// initialize
    }
}

// catch ENTER key in input box
function keypress() {
	if (window.event && window.event.keyCode == 13) {
		getResult();
	}
}

function showLoadingImg() {
	var img = document.getElementById("searchButton");
	img.src = "images/ui-anim_basic_16x16.gif"; 
}

function showSearchImg() {
	var img = document.getElementById("searchButton");
	img.src = "images/loupe.png"; 
}

function showOrHideClearSearchInputButton() {
	var div = document.getElementById("clearSearchInputButton");
	if(query.value != null && query.value.length > 0) {
		div.style.display = 'block';
	} else {
		div.style.display = 'none';
	}
}

function clearInput() {
	var div = document.getElementById("clearSearchInputButton");
	div.style.display = 'none';
	query.value = "";
	showSearchImg();
	System.Gadget.Flyout.show = false;
}

// do query and get results
function getResult() {
	showLoadingImg();
    // select all text in the query box
    if (System.Gadget.Flyout.show) {
      fetchResult(query.value);
      query.createTextRange().select(); 
      query.focus();
    } else {
      System.Gadget.Flyout.file = "flyout.htm";
      System.Gadget.Flyout.show = true;
      System.Gadget.Flyout.onShow = function() {
	     fetchResult(query.value);
	     query.createTextRange().select(); 
	     query.focus();
      };
    }
}

function getNullForUndefined(object) {
	if(typeof object != 'undefined') {
		return object;
	} else {
		return null;
	}
}

// q is the query to fetch
function fetchResult(q) {
  try { 
   if (q && q.length > 0){
    var flyoutDoc = System.Gadget.Flyout.document;
    var flyout = System.Gadget.Flyout;
    flyoutDoc.getElementById("word").innerHTML = q;
    var eq = encodeURIComponent(q);
    var url = host + '/search_service' + '?q=' + eq;
    new Ajax.Request(url,
    {
    method:'get',
    onSuccess: function(transport){
    	showSearchImg();
      //var response = transport.responseText || "no response text";
      var data = transport.responseText.evalJSON(true);  
      var coverHref = host + "/covers.svc?h=70&t=m&w=70";
      var html = '<div class="listView">';
      for (var i = 0; i < data.length; i++) {
      var record = new OpacRecord(
    		  				i+1,
    		  				data[i].id,
    		  				data[i].title,
    		  				getNullForUndefined(data[i].author),
    		  				getNullForUndefined(data[i].publisher),
    		  				getNullForUndefined(data[i].language),
    		  				getNullForUndefined(data[i].isbn),
    		  				getNullForUndefined(data[i].issn),
    		  				data[i].sourceName,
    		  				data[i].sourceType,
    		  			   (getNullForUndefined(data[i].externalCoverUrl) != null)? data[i].externalCoverUrl : coverHref + "&rid=" + data[i].id
    		  				);
        html += record.toJSON();
      }
      html += '</div>';
      if(data.length == 0) {
       html = '<h1 id="noResultsTitle" class="breadCrumb">';
       html += '<span style="color: rgb(153, 0, 0);"> Your search ';
       html += '<span class="noResultsTitleKeyword">"';
       html += q;
       html += '"</span>';
       html += ' did not match any records.</span>';
       html += '</h1>';
      }
      flyoutDoc.getElementById("result").innerHTML = html;
    },
    onFailure: function(){
    flyoutDoc.getElementById("result").innerHTML = 'Something went wrong...';
    showSearchImg();
     }
  });
    }
  } catch (e) {
    var flyoutDoc = System.Gadget.Flyout.document;
    flyoutDoc.getElementById("result").innerHTML = "<b>" + e + "</b>";
    showSearchImg();
  }
}
